/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef AI_CENTER_H
#define AI_CENTER_H

#include "ai.h"

class phAI_Coach : public phAI
{
public:
	RPH_THING_MODULE

	phAI_Coach();
	virtual ~phAI_Coach();

	void process( ThingManager *tm);

	std::string type() const { return std::string( "phAI_Coach");}
	bool is_a( const std::string &s) const {
		if( s != phAI_Coach::type()) return phAI::is_a( s);
		return true;
	}

	gmTE call_ccmd( const std::string &key, gmCCArg &args);
	std::string list_ccmd( const std::string &p_prefix);

protected:
	static std::map <const std::string, THING_COMMAND_FN> m_ccmd;

	// This AI was designed for coaches.
	bool accept_host( ThingControlBlock *t) {
		if( t->is_free()) return false;
		if( !(t->m_thing->is_a( "phCoach"))) return false;
		return true;
	}

private:

	phAI_Coach( const phAI_Coach &);
	phAI_Coach &operator =( const phAI_Coach &);
};

#endif
