/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef AI_FORWARD_H
#define AI_FORWARD_H

#include "ai_player.h"

class phReferee;
class phCoach;
class phTeam;

class phAI_Forward : public phAI_Player
{
public:
	RPH_THING_MODULE

	phAI_Forward();
	virtual ~phAI_Forward();

	void process( ThingManager *tm);

	std::string type() const { return std::string( "phAI_Forward");}
	bool is_a( const std::string &s) const {
		if( s != phAI_Forward::type()) return phAI_Player::is_a( s);
		return true;
	}

	gmTE call_ccmd( const std::string &key, gmCCArg &args);
	std::string list_ccmd( const std::string &p_prefix);

	void process_coach_message(
		phAI_Message *m,
		phReferee *ref,
		phCoach *coa,
		phTeam *us,
		phTeam *them);

protected:
	static std::map <const std::string, THING_COMMAND_FN> m_ccmd;

	// This AI was designed for players.
	bool accept_host( ThingControlBlock *t) {
		if( t->is_free()) return false;
		if( !(t->m_thing->is_a( "phPlayer"))) return false;
		return true;
	}

private:

	phAI_Forward( const phAI_Forward &);
	phAI_Forward &operator =( const phAI_Forward &);
};

#endif
