/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef AI_PLAYER_H
#define AI_PLAYER_H

#include "ai_skater.h"

class phCoach;
class phReferee;
class phTeam;
class phPerson;
class phPlayer;
class phUserControl;

DECLARE_AI_TASK( task___ply_ready_stand);
DECLARE_AI_TASK( task___ply_get_puck_control);

class task___ply_shoot : public phAI_Task
{
public:
        std::string m_anim;
	std::string m_shot_type;
	rgVector m_heading;
	bool m_windup;
	void (*m_call_back)( task___ply_shoot *);
	phUserControl *m_uc;
	phPerson *m_per;

	task___ply_shoot(){
		m_windup = false;
		m_call_back = 0;
		m_uc = 0;
		m_per = 0;
	}
	virtual ~task___ply_shoot(){}
	void do_task() { throw this;}
};


class phAI_Player : public phAI_Skater
{
public:
	RPH_THING_MODULE

	phAI_Player();
	virtual ~phAI_Player();

	//void process( ThingManager *tm);

	std::string type() const { return std::string( "phAI_Player");}
	bool is_a( const std::string &s) const {
		if( s != phAI_Player::type()) return phAI_Skater::is_a( s);
		return true;
	}

	gmTE call_ccmd( const std::string &key, gmCCArg &args);
	std::string list_ccmd( const std::string &p_prefix);


	void check_messages(
		phReferee *ref,
		phCoach *coa,
		phTeam *us,
		phTeam *them);
	virtual void process_coach_message(
		phAI_Message *m,
		phReferee *ref,
		phCoach *coa,
		phTeam *us,
		phTeam *them){}
	virtual void process_referee_message(
		phAI_Message *m,
		phReferee *ref,
		phCoach *coa,
		phTeam *us,
		phTeam *them){}
	virtual void process_teammate_message(
		phAI_Message *m,
		phReferee *ref,
		phCoach *coa,
		phTeam *us,
		phTeam *them){}
	virtual void process_opponent_message(
		phAI_Message *m,
		phReferee *ref,
		phCoach *coa,
		phTeam *us,
		phTeam *them){}


protected:
	static std::map <const std::string, THING_COMMAND_FN> m_ccmd;

	// This AI was designed for players.
	bool accept_host( ThingControlBlock *t) {
		if( t->is_free()) return false;
		if( !(t->m_thing->is_a( "phPlayer"))) return false;
		return true;
	}

	std::string shoot( phPlayer *ply, task___ply_shoot *t);

private:

	phAI_Player( const phAI_Player &);
	phAI_Player &operator =( const phAI_Player &);
};

#endif
