/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef AI_REFEREE_H
#define AI_REFEREE_H

#include "ai_skater.h"

class phAI_Referee : public phAI_Skater
{
public:
	RPH_THING_MODULE

	phAI_Referee();
	virtual ~phAI_Referee();

	void process( ThingManager *tm);

	std::string type() const { return std::string( "phAI_Referee");}
	bool is_a( const std::string &s) const {
		if( s != phAI_Referee::type()) return phAI_Skater::is_a( s);
		return true;
	}

	gmTE call_ccmd( const std::string &key, gmCCArg &args);
	std::string list_ccmd( const std::string &p_prefix);

protected:
	static std::map <const std::string, THING_COMMAND_FN> m_ccmd;

	// This AI was designed for referees.
	bool accept_host( ThingControlBlock *t) {
		if( t->is_free()) return false;
		if( !(t->m_thing->is_a( "phReferee"))) return false;
		return true;
	}

	bool m_game_started;
	bool m_play_stopped;

private:

	phAI_Referee( const phAI_Referee &);
	phAI_Referee &operator =( const phAI_Referee &);
};

#endif
