/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "coach.h"
#include "engine/engine_game.h"
#include <rg3DRom.h>

std::map <const std::string, THING_COMMAND_FN> phCoach::m_ccmd;

extern "C" gmThing *spw_phCoach()
{
	return new phCoach();
}

extern "C" int del_phCoach( gmThing *t)
{
	delete t;
	return 0;
}

RPH_THING_MODULE_MAIN_FUNCTION( phCoach)
{
	p_ge->m_thing_manager->add_to_spawn_list( "phCoach", spw_phCoach);

	p_ge->m_thing_manager->add_to_delete_list( "phCoach", del_phCoach);

	return 0;
}

phCoach::phCoach()
{

	if( !(m_ccmd.empty())) return;
}

phCoach::~phCoach()
{
}

gmTE phCoach::call_ccmd( const std::string &key, gmCCArg &args)
{
	std::map <const std::string, THING_COMMAND_FN> ::
		const_iterator iter = m_ccmd.find( key);
	if( iter == m_ccmd.end()) return phPerson::call_ccmd( key, args);
	return (iter->second)( args);
}

std::string phCoach::list_ccmd( const std::string &p_prefix)
{
	std::map <const std::string, THING_COMMAND_FN> :: const_iterator iter =
		m_ccmd.begin();
	std::string tmp;
	for( ; iter != m_ccmd.end(); ++iter) {
		tmp += p_prefix + phCoach::type() + "::" + (iter->first) +
			"\n";
	}
	tmp += phPerson::list_ccmd( p_prefix);
	return tmp;
}


void phCoach::process( ThingManager *tm)
{
	// Think...think...think...
	ThingControlBlock *ai = get_ai();
	if( ai && !(ai->is_free())) ai->m_thing->process( tm);
}

