/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "goalie.h"
#include "engine/engine_graphics.h"
#include "engine/engine_game.h"
#include <rg3DRom.h>

std::map <const std::string, THING_COMMAND_FN> phGoalie::m_ccmd;

extern "C" gmThing *spw_phGoalie()
{
	return new phGoalie();
}

extern "C" int del_phGoalie( gmThing *t)
{
	delete t;
	return 0;
}

RPH_THING_MODULE_MAIN_FUNCTION( phGoalie)
{
	p_ge->m_thing_manager->add_to_spawn_list( "phGoalie", spw_phGoalie);

	p_ge->m_thing_manager->add_to_delete_list( "phGoalie", del_phGoalie);

	return 0;
}

phGoalie::phGoalie()
{
	if( !(m_ccmd.empty())) return;
}

phGoalie::~phGoalie()
{
}

gmTE phGoalie::call_ccmd( const std::string &key, gmCCArg &args)
{
	std::map <const std::string, THING_COMMAND_FN> :: const_iterator iter =
		m_ccmd.find( key);
	if( iter == m_ccmd.end()) return phPlayer::call_ccmd( key, args);
	return (iter->second)( args);
}

std::string phGoalie::list_ccmd( const std::string &p_prefix)
{
	std::map <const std::string, THING_COMMAND_FN> :: const_iterator iter =
		m_ccmd.begin();
	std::string tmp;
	for( ; iter != m_ccmd.end(); ++iter) {
		tmp += p_prefix + phGoalie::type() + "::" + (iter->first) +
			"\n";
	}
	tmp += phPlayer::list_ccmd( p_prefix);
	return tmp;
}

void phGoalie::process( ThingManager *tm)
{
	gmPhyModel::process( tm);

	// Think...think...think...
	ThingControlBlock *ai = get_ai();
	if( ai && !(ai->is_free())) ai->m_thing->process( tm);

}
